/*************************************************************
 * NEMO-Q KAT120B kijelző próba
 * 
 * A program felváltva 000, 123, 456, 789 feliratot jelenít meg.
 * A kijelző TAKT (órajel) és DATA (adat) bemeneteit egy-egy
 * NPN tranzisztor segítségével hajtjuk meg, ezek bázisát
 * vezárli az Arduino D3 és D4 kimenete.
 *
 * Cserny István, Debrecen, 2017. október 17.
 *************************************************************/

#define CLKPIN  3 
#define DATAPIN 4  

void setup() {
  pinMode(CLKPIN, OUTPUT);
  pinMode(DATAPIN, OUTPUT);  
  digitalWrite(DATAPIN,LOW);
  digitalWrite(CLKPIN,LOW);
}

void loop() {
  myshiftOut(B00000000); // 000
  myshiftOut(B00000000); 
  myshiftOut(B01111110); 
  myshiftOut(B11111111); 
  delay(1000);  
  myshiftOut(B00010000); // 123
  myshiftOut(B00100011); 
  myshiftOut(B01111110); 
  myshiftOut(B11111111); 
  delay(1000);
  myshiftOut(B01000000); // 456
  myshiftOut(B01010110); 
  myshiftOut(B01111110); 
  myshiftOut(B11111111); 
  delay(1000);  
  myshiftOut(B01110000); // 789
  myshiftOut(B10001001); 
  myshiftOut(B01111110); 
  myshiftOut(B11111111); 
  delay(1000);    
}  

// Egy bájt kiküldése bitenként (MSBFIRST mód)
void myshiftOut(uint8_t val) {
  uint8_t i;
  for (i = 0; i < 8; i++)  {
    digitalWrite(DATAPIN,bitRead(val,7-i)); // Adatvonal beállítása
    delayMicroseconds(10);    
    digitalWrite(CLKPIN, HIGH);             // Órajel aktíválás
    delayMicroseconds(10);
    digitalWrite(CLKPIN, LOW);	            // Órajel alaphelyzetbe
    delayMicroseconds(10);
  }
}




