/*************************************************************
 * NEMO-Q KAT120B kijelző próba
 * 
 * A program 000-tól 999-ig számol és jeleníti meg a számot.
 * A kijelző TAKT (órajel) és DATA (adat) bemeneteit egy-egy
 * NPN tranzisztor segítségével hajtjuk meg, ezek bázisát
 * vezérli az Arduino D3 és D4 kimenete.
 * A hátoldali kapcsolók mind ON állásban legyenek!
 *
 * Cserny István, Debrecen, 2017. október 17.
 *************************************************************/

#define CLKPIN  3 
#define DATAPIN 4  

uint16_t n;
uint8_t d1, d2, d3;

void setup() {
  pinMode(CLKPIN, OUTPUT);   // Órajel kimenet 
  pinMode(DATAPIN, OUTPUT);  // Adat kimenet
  digitalWrite(DATAPIN,LOW); // Adat kimenent alaphelyzetbe
  digitalWrite(CLKPIN,LOW);  // Órajel kimenet alaphelyzetbe
}

void loop() {
  for(n=0; n<1000; n++) {
    d1 = n/100;              // Százasok
    d2 = n/10%10;            // Tízesek
    d3 = n%10;               // Egyesek
    myshiftOut(d1<<4);       // Egyesek kiküldése
    myshiftOut((d2<<4)+d3);  // Tízesek és százasok kiküldése
    myshiftOut(B01111110);   // Kódkapcsoló állása
    myshiftOut(B11111111);   // Üzenet vége jelzés és szinkronizálás
    delay(100);    
  }
}  

// Egy bájt kiküldése bitenként (MSBFIRST mód)
void myshiftOut(uint8_t val) {
  uint8_t i;
  for (i = 0; i < 8; i++)  {
    digitalWrite(DATAPIN,bitRead(val,7-i)); // Adatvonal beállítása
    delayMicroseconds(10);    
    digitalWrite(CLKPIN, HIGH);             // Órajel aktíválás
    delayMicroseconds(10);
    digitalWrite(CLKPIN, LOW);	            // Órajel alaphelyzetbe
    delayMicroseconds(10);
  }
}





